Unit USortable;

////////////////////////////////////////////////////////////////////////////////
//  USortable                                                                 //
//                                                                            //
//  Enthlt die Abstrakte Klasse TSortable, die sortierbaren Elementen dient  //
////////////////////////////////////////////////////////////////////////////////



Interface


Type
  TSortable = Class(TObject)
  Public
    Function Text : String; Virtual; Abstract;

    Function Equal(Element : TSortable) : Boolean; Virtual; Abstract;
    Function LT(Element : TSortable) : Boolean; Virtual; Abstract;     // Less Than

    Function GT(Element : TSortable) : Boolean;                        // Greater Than
    Function GoE(Element : TSortable) : Boolean;                       // Greater or Equal
    Function LoE(Element : TSortable) : Boolean;                       // Less or Equal
    Function Unequal(Element : TSortable) : Boolean;
  End;  // TSortable



Implementation


////////////////////////////////////////////////////////////////////////////////
//  TSortable.GT                                                              //
//                                                                            //
//  Gibt an, ob das Element grer ist                                        //
////////////////////////////////////////////////////////////////////////////////

Function TSortable.GT;
Begin
  Result := Not(Equal(Element) Or LT(Element));
End;  // TSortable.GT


////////////////////////////////////////////////////////////////////////////////
//  TSortable.GoE                                                             //
//                                                                            //
//  Gibt an, ob das Element grer oder gleich ist                            //
////////////////////////////////////////////////////////////////////////////////

Function TSortable.GoE;
Begin
  Result := GT(Element) Or Equal(Element);
End;  // TSortable.GoE


////////////////////////////////////////////////////////////////////////////////
//  TSortable.LoE                                                             //
//                                                                            //
//  Gibt an, ob das Element kleiner oder gleich ist                           //
////////////////////////////////////////////////////////////////////////////////

Function TSortable.LoE;
Begin
  Result := LT(Element) Or Equal(Element);
End;  // TSortable.LoE


////////////////////////////////////////////////////////////////////////////////
//  TSortable.Unequal                                                         //
//                                                                            //
//  Gibt an, ob das Element ungleich ist                                      //
////////////////////////////////////////////////////////////////////////////////

Function TSortable.Unequal;
Begin
  Result := Not Equal(Element);
End;  // TSortable.Unequal

End.  // USortable

